package ringbuttonwrapper;

import main.java.com.victor.ringbutton.RingButton;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("RingButton")
public class ringButtonWrapper extends ViewWrapper<RingButton> implements DesignerCustomView  {


	private BA ba;
	private String eventName;
        private RingButton cv;
 
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new RingButton(ba.context, null);
                this.setObject(cv);
                addListener();
 	}


    @Hide
    public void addListener(){
        cv.setCallback(new RingButton.Callback() {
//            @Override
            public void top_clicked() {

              if (ba.subExists(eventName + "_top_clicked")) {
                ba.raiseEvent2(ba, false, eventName + "_top_clicked", true, new Object[0]);
              }
            }

//            @Override
            public void bottom_clicked() {

              if (ba.subExists(eventName + "_bottom_clicked")) {
                ba.raiseEvent2(ba, false, eventName + "_bottom_clicked", true, new Object[0]);
              }
            }

        });
    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

    public void setUpBitmap(Bitmap upbitmap) {
         cv.setUpBitmap(upbitmap);
         cv.invalidate();
    }

    public void setDownBitmap(Bitmap downbitmap) {
         cv.setDownBitmap(downbitmap);
         cv.invalidate();
    }

    public void setDownText(String downtext) {
         cv.setDownText(downtext);
         cv.invalidate();
    }

    public void setUpText(String uptext) {
         cv.setUpText(uptext);
         cv.invalidate();
    }




    public void setCircleColor(int color) {
         cv.setCircleColor(color);
         cv.invalidate();
    }

    public void setBorderColor(int color) {
         cv.setBorderColor(color);
         cv.invalidate();
    }

    public void setPressedColor(int color) {
         cv.setPressedColor(color);
         cv.invalidate();
    }

    public void setBorderWidth(int width) {
         cv.setBorderWidth(width);
         cv.invalidate();
    }

    public void setDividerColor(int color) {
         cv.setDividerColor(color);
         cv.invalidate();
    }

    public void setDividerHighLightColor(int color) {
         cv.setDividerHighLightColor(color);
         cv.invalidate();
    }

    public void setDividerShadowColor(int color) {
         cv.setDividerShadowColor(color);
         cv.invalidate();
    }

    public void setDividerSize(int size) {
         cv.setDividerSize(size);
         cv.invalidate();
    }

}
